package server;

import java.util.*;
import java.io.*;

public class ServerComm
{
    API server;
    BufferedReader in;
    PrintWriter out;
    public ServerComm(API server, InputStream in, OutputStream out) { 
        this.server = server;
        this.in = new BufferedReader(new InputStreamReader(in));
        this.out = new PrintWriter(out, true);
    }

    public void run() {
        try {
            for(;;) {
                doCommand();
            }
        } catch(IOException e) {
        }
    }

    // implementation
    void putStr(String s) {
        if( s == null ) out.println("0");
        else out.println("1"+s);
    }
    String getStr() throws IOException {
        String s = in.readLine();
        if( s.equals("0") ) return null;
        else return s.substring(1);
    }
    String next(StringTokenizer st) {
        return st.nextToken();
    }
    int nextInt(StringTokenizer st) {
        return Integer.parseInt(st.nextToken());
    }
    void doCommand() throws IOException {
        try {
            StringTokenizer st = new StringTokenizer(getStr());
            String command = st.nextToken();
            String ret = null;
            if( command.equals("getProjectCount") ) {
                ret = ""+server.getProjectCount();
            }
            else if( command.equals("getProjectName") ) {
                ret = server.getProjectName(next(st), nextInt(st));
            }
            else if( command.equals("getProjectAvg") ) {
                ret = server.getProjectAvg(next(st), nextInt(st));
            }
            else if( command.equals("getStudentCount") ) {
                ret = ""+server.getStudentCount();
            }
            else if( command.equals("getStudentID") ) {
                ret = server.getStudentID(next(st), nextInt(st));
            }
            else if( command.equals("getStudentAvg") ) {
                ret = server.getStudentAvg(next(st), nextInt(st));
            }
            else if( command.equals("getGrade") ) {
                ret = server.getGrade(next(st), nextInt(st), nextInt(st));
            }
            else if( command.equals("setGrade") ) {
                ret = server.setGrade(next(st), nextInt(st), nextInt(st), next(st));
            }
            putStr(ret);
        } catch(NumberFormatException e) {
            putStr(null);
        }
    }

}
